Unit AER14R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AER14R(NM :Integer; N :Integer; var D :Array of Real;
                var E :Array of Real; var E2 :Array of Real;
                M :Integer; var W :Array of Real;
                var IND :Array of Integer; var Z :Array of Real;
                var IERR :Integer; var RV1 :Array of Real;
                var RV2 :Array of Real; var RV3 :Array of Real;
                var RV4 :Array of Real; var RV6 :Array of Real);

implementation

procedure AER14R(NM :Integer; N :Integer; var D :Array of Real;
                var E :Array of Real; var E2 :Array of Real;
                M :Integer; var W :Array of Real;
                var IND :Array of Integer; var Z :Array of Real;
                var IERR :Integer; var RV1 :Array of Real;
                var RV2 :Array of Real; var RV3 :Array of Real;
                var RV4 :Array of Real; var RV6 :Array of Real);
var
I,J,P,Q,R,S,II,IP,JJ,ITS,TAG,GROUP :Integer;
U,V,UK,XU,X0,X1,EPS2,EPS3,EPS4,NORM,ORDER,MACHEP :Real;
const
SYS051 :Real = 1.192093E-07;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32;
begin
MACHEP := SYS051;
IERR := 0;
if ( M = 0 ) 
 then goto _32;
TAG := 0;
ORDER := 1.0-E2[0];
Q := 0;
{  ********** }
_1:
P := Q+1;
for Q:=P to N do
 begin
  if ( Q = N ) 
   then goto _3;
  if ( E2[Q+0] = 0.0 ) 
   then goto _3;
_2:
 end;
{  ********** }
_3:
TAG := TAG+1;
S := 0;
for R:=1 to M do
 begin
  if ( IND[R-1] <> TAG ) 
   then goto _31;
  ITS := 1;
  X1 := W[R-1];
  if ( S <> 0 ) 
   then goto _7;
{  ********** }
  XU := 1.0;
  if ( P <> Q ) 
   then goto _4;
  RV6[P-1] := 1.0;
  goto _28;
_4:
  NORM := Abs(D[P-1]);
  IP := P+1;
  for I:=IP to Q do
   begin
_5:
    NORM := NORM+Abs(D[I-1])+Abs(E[I-1]);
   end;
{  ********** }
  EPS2 := 1.0E-3*NORM;
  EPS3 := MACHEP*NORM;
  UK := (Q-P+1);
  EPS4 := UK*EPS3;
  UK := EPS4/Sqrt(UK);
  S := P;
_6:
  GROUP := 0;
  goto _8;
{  ********** }
_7:
  if ( Abs(X1-X0) >= EPS2 ) 
   then goto _6;
  GROUP := GROUP+1;
  if ( ORDER*(X1-X0) <= 0.0 ) 
   then X1 := X0+ORDER*EPS3;
{  ********** }
_8:
  V := 0.0;
  for I:=P to Q do
   begin
    RV6[I-1] := UK;
    if ( I = P ) 
     then goto _10;
    if ( Abs(E[I-1]) < Abs(U) ) 
     then goto _9;
{  ********** }
    XU := U/E[I-1];
    RV4[I-1] := XU;
    RV1[I-2] := E[I-1];
    RV2[I-2] := D[I-1]-X1;
    RV3[I-2] := 0.0;
    if ( I <> Q ) 
     then RV3[I-2] := E[I+0];
    U := V-XU*RV2[I-2];
    V := -XU*RV3[I-2];
    goto _11;
_9:
    XU := E[I-1]/U;
    RV4[I-1] := XU;
    RV1[I-2] := U;
    RV2[I-2] := V;
    RV3[I-2] := 0.0;
_10:
    U := D[I-1]-X1-XU*V;
    if ( I <> Q ) 
     then V := E[I+0];
_11:
   end;
  if ( U = 0.0 ) 
   then U := EPS3;
  RV1[Q-1] := U;
  RV2[Q-1] := 0.0;
  RV3[Q-1] := 0.0;
{  ********** }
_12:
  for II:=P to Q do
   begin
    I := P+Q-II;
    RV6[I-1] := (RV6[I-1]-U*RV2[I-1]-V*RV3[I-1])/RV1[I-1];
    V := U;
    U := RV6[I-1];
_13:
   end;
{  ********** }
  if ( GROUP = 0 ) 
   then goto _18;
  J := R;
  for JJ:=1 to GROUP do
   begin
_14:
    J := J-1;
    if ( IND[J-1] <> TAG ) 
     then goto _14;
    XU := 0.0;
    for I:=P to Q do
     begin
_15:
      XU := XU+RV6[I-1]*Z[(I-1)+(J-1)*NM];
     end;
    for I:=P to Q do
     begin
_16:
      RV6[I-1] := RV6[I-1]-XU*Z[(I-1)+(J-1)*NM];
     end;
_17:
   end;
_18:
  NORM := 0.0;
  for I:=P to Q do
   begin
_19:
    NORM := NORM+Abs(RV6[I-1]);
   end;
  if ( NORM >= 1.0 ) 
   then goto _26;
{  ********** }
  if ( ITS = 5 ) 
   then goto _25;
  if ( NORM <> 0.0 ) 
   then goto _20;
  RV6[S-1] := EPS4;
  S := S+1;
  if ( S > Q ) 
   then S := P;
  goto _22;
_20:
  XU := EPS4/NORM;
  for I:=P to Q do
   begin
_21:
    RV6[I-1] := RV6[I-1]*XU;
   end;
{  ********** }
_22:
  for I:=IP to Q do
   begin
    U := RV6[I-1];
{  ********** }
    if ( RV1[I-2] <> E[I-1] ) 
     then goto _23;
    U := RV6[I-2];
    RV6[I-2] := RV6[I-1];
_23:
    RV6[I-1] := U-RV4[I-1]*RV6[I-2];
_24:
   end;
  ITS := ITS+1;
  goto _12;
{  ********** }
_25:
  IERR := -R;
  XU := 0.0;
  goto _28;
{  ********** }
_26:
  U := 0.0;
  for I:=P to Q do
   begin
_27:
    U := U+IntPower(RV6[I-1],2);
   end;
  XU := 1.0/Sqrt(U);
_28:
  for I:=1 to N do
   begin
_29:
    Z[(I-1)+(R-1)*NM] := 0.0;
   end;
  for I:=P to Q do
   begin
_30:
    Z[(I-1)+(R-1)*NM] := RV6[I-1]*XU;
   end;
  X0 := X1;
_31:
 end;
if ( Q < N ) 
 then goto _1;
_32:
end;

end.
